#include "/software/Linux64/matlab-7.5/extern/include/mex.h"
#include <math.h>

double mod(double,double);/* matlab-like mod function */

void mexFunction(int nlhs,
                  mxArray *plhs[],
                  int nrhs,
                  const mxArray *prhs[])
{
double *y,sum=0;
mxArray *sv;
int i,m,n;

/*get the size of the input matrix*/
m=mxGetM(prhs[0]);
n=mxGetN(prhs[0]); 
mexPrintf("Input matrix is %d by %d\n",m,n);

/* one output matrix */
plhs[0]=mxCreateDoubleMatrix(1,1,mxREAL);

/*initialize*/
sv=mxCreateDoubleMatrix(m,1,mxREAL);

/* y is the pointer to the array of output matrix */

mexCallMATLAB(1,&sv,1,&prhs[0],"svd");

y=mxGetPr(sv); 

for(i=0;i<m;i++)
	{
	sum = sum+mod(y[i],1);
	}

y=mxGetPr(plhs[0]);
*y=sum;
mxDestroyArray(sv);
return;
}

double mod(double x,double y)
{

  if(y!=0.)
    return(x - y*floor(x/y));
  else
    return(x);
}

